/// <reference types="jqueryui" />
import { DropAcceptOptions } from '../Droppable';
import { Offset } from '@generalizers/react-utils';
import { FunctionComponent, HTMLProps } from 'react';
export interface DraggableProps extends HTMLProps<HTMLDivElement> {
    dragRef?: (ref: HTMLDivElement) => void;
    onDropDelete?: boolean;
    onStartDragRemove?: boolean;
    removeWhileDragging?: boolean;
    dropAcceptOptions?: (dao: DropAcceptOptions) => any;
    addClasses?: boolean;
    appendTo?: Element;
    axis?: 'x' | 'y';
    cancel?: 'input' | 'textarea' | 'button' | 'select' | 'option';
    classes?: JQueryUI.DraggableClasses;
    connectToSortable?: Element;
    containment?: Element | 'parent' | 'document' | 'window' | [number, number, number, number];
    cursor?: 'help' | 'wait' | 'crosshair' | 'not-allowed' | 'zoom-in' | 'grab';
    cursorAt?: {
        left: OffsetValue;
        right: OffsetValue;
        top: OffsetValue;
        bottom: OffsetValue;
    };
    delay?: number;
    disabled?: boolean;
    distance?: number;
    grid?: Offset;
    handle?: Element;
    helper?: 'original' | 'clone' | Element;
    iframeFix?: boolean;
    opacity?: number;
    refreshPositions?: boolean;
    revert?: boolean | string | (() => boolean);
    revertDuration?: number;
    scroll?: boolean;
    scrollSensitivity?: number;
    scrollSpeed?: number;
    snap?: boolean | Element;
    snapMode?: 'inner' | 'outer' | 'both';
    snapTolerance?: number;
    stack?: string;
    zIndex?: number;
    draggableStart?: JQueryUI.DraggableEvent;
    draggableEnd?: JQueryUI.DraggableEvent;
    draggableDrag?: JQueryUI.DraggableEvent;
}
declare type OffsetValue = string | number;
export declare const Draggable: FunctionComponent<DraggableProps>;
export {};
